//  ** 5DOF - Using multi-joysticks with servo positioning control


#include <Servo.h>           //include servo library

Servo servo1;                // creating servo object
Servo servo2;
Servo servo3;
Servo servo4;
Servo servo5;

int joystick_x = A0;        // horizontal joystick movement and control of Revolving Base                                      
int joystick_y = A3;        // vertical joystick movement and control Shoulder       
int joystick_z = A4;        // vertical joystick movement and control of Elbow 
int joystick_a = A5;        // horizontal joystick movement and control of Wrist
int joystick_b = A1;        // vertical joystick movement and control of Claw
                            
int pos_x;                  // declaring variable to store horizontal value for joystick_x
int pos_y;                  // declaring variable to store vertical value for joystick_y
int pos_z;                  // declaring variable to store vertical value for joystick_z
int pos_a;                  // declaring variable to store vertical value for joystick_a
int pos_b;                  // declaring variable to store vertical value for joystick_b

int servo1_pos= 90;         // 90  starting position for servo1 - Revolving base
int servo2_pos= 100;       // 200  starting position for servo2 - Shoulder 
int servo3_pos= 90;          // 0  starting position for servo3 - Elbow
int servo4_pos= 65;          // 5  starting position for servo4 - Wrist
int servo5_pos= 88;        // 180  starting position for servo5 - Claw

void setup ( ) 
{
Serial.begin (9600) ;


servo1.attach (8);            // servo1 attached pin - Revolving Base
servo2.attach (9);            // servo2 attached pin - Shoulder
servo3.attach (12);           // servo3 attached pin - Elbow
servo4.attach (11);           // servo4 attached pin - Wrist
servo5.attach (10);           // servo5 attached pin - Claw

servo1.write (servo1_pos);           
servo2.write (servo2_pos);
servo3.write (servo3_pos);
servo4.write (servo4_pos);
servo5.write (servo5_pos);

pinMode (joystick_x, INPUT) ;                     
pinMode (joystick_y, INPUT) ;  
pinMode (joystick_z, INPUT) ;
pinMode (joystick_a, INPUT) ;   
pinMode (joystick_b, INPUT) ;                 
}

void loop ( ) 
{
pos_x = analogRead (joystick_x) ;  
pos_y = analogRead (joystick_y) ;  
pos_z = analogRead (joystick_z) ;
pos_a = analogRead (joystick_a) ;
pos_b = analogRead (joystick_b) ;



// Activity for joystick_x and servo1      ** Revolving servo

if (pos_x < 300)            //if the horizontal value from joystick is less than 300
{
  if (servo1_pos < 0)      //first servo moves right- 30
  { 
  } 
  else
  { 
    servo1_pos = servo1_pos - 20; 
    servo1.write ( servo1_pos ) ; 
    delay (60); 
  } 
} 
if (pos_x > 700)   
{
  if (servo1_pos > 180)  
  {  
  }  
  else
  {
  servo1_pos = servo1_pos + 20;     
  servo1.write (servo1_pos) ;
  delay (60) ;
  }
}



// Activity for joystick_y and servo2   -    ** Shoulder servo

if (pos_y <300)   //if the vertical value from joystick is less than 300.  Keep pos_y set to 300 in order to help keep servo2_pos level.
{
  if (servo2_pos < 60)   //second servo moves down. Keep servo2_pos set to 60 in order to keep base level.
  { 
  } 
  else
  { 
    servo2_pos = servo2_pos - 20; 
    servo2.write (servo2_pos); 
    delay (120); 
   } 
 } 
  if (pos_y > 700)    //  700 Original default setting.
{
  if (servo2_pos > 90)    //  90  Original default setting - level balance.
  {  
  }        
  else
  {
  servo2_pos = servo2_pos + 20;
  servo2.write(servo2_pos) ;
  delay (120) ;
  }
}


// Activity for joystick_z and servo3 -    ** Elbow servo

if (pos_z < 300)   //if the vertical value from joystick is less than 300.   
{
  if (servo3_pos < 100)   //100

  { 
    servo3_pos = servo3_pos - 20; 
    servo3.write (servo3_pos); 
    delay (130); 
   } 
 } 
  if (pos_z > 700)   //700
{
  if (servo3_pos > 70)     //70
  {  
  }        
  else
  {
  servo3_pos = servo3_pos + 20;
  servo3.write(servo3_pos) ;
  delay (130) ;
  }
}

// Activity for joystick_y and servo2   -    ** Wrist

if (pos_a < 300)   //if the vertical value from joystick is less than 300.  Keep pos_y set to 300 in order to help keep servo2_pos level.
{
  if (servo4_pos < 0)   //0  - Half way around to the left
  { 
  } 
  else
  { 
    servo4_pos = servo4_pos - 20; 
    servo4.write (servo4_pos); 
    delay (100); 
   } 
 } 
  if (pos_a > 700)    //  700 Original default setting
{
  if (servo4_pos > 160)    //  160  - Half way around to the right
  {  
  }        
  else
  {
  servo4_pos = servo4_pos + 20;  //20
  servo4.write(servo4_pos) ;
  delay (100) ;
  }
}


// Activity for joystick_x and servo1      ** Claw servo

if (pos_b < 300)            //if the horizontal value from joystick is less than 300
{
  if (servo5_pos < 50)      //first servo moves right
  { 
  } 
  else
  { 
    servo5_pos = servo5_pos - 20; 
    servo5.write ( servo5_pos ) ; 
    delay (100); 
  } 
} 
if (pos_b > 700)   
{
  if (servo5_pos > 80)  // 80
  {  
  }  
  else
  {
  servo5_pos = servo5_pos + 20;     
  servo5.write (servo5_pos) ;
  delay (100) ;
  }
 }

} // End of Program.
